// Elan no Nanika plugin for AmaRecCo
// Author: elz (http://zoome.jp/elz/)
// Released under the Artistic License

#include <stdio.h>
#include <windows.h>
#include <wingdi.h>
#include "PluginInput.h"
#include "config.h"

ConfigValues::ConfigValues()
{
    setIndex(0);

    strncpy(tsFormat, DEF_TIMESTAMPFORMAT, MAX_LEN);
    buttonPosX = 0;
    buttonPosY = 0;
    buttonMode = CORNER;

    strncpy(fontName, DEF_FONTNAME, MAX_LEN);
    fontHeight = 10;
    fontAlign = TOP_LEFT;
    fontColor = RGB(255, 255, 255);
    backgroundColor = RGB(0, 0, 0);
    isTransparent = false;

    strncpy(pluginName, PLUGIN_NAME, MAX_LEN);
}

void
ConfigValues::setPlugin(const INPUT_PLUGIN_TABLE* t)
{
    pluginTable = t;
    strncpy(pluginName, pluginTable->pcName, MAX_LEN);
}

void
ConfigValues::setIndex(int i)
{
    index = i;
    snprintf(indexKey, MAX_LEN, "VIDEO(%d)", index + 1);
}

void
ConfigValues::reloadAll()
{
    pluginTable->af->ini_int_load(pluginName, "buttonMode", &buttonMode);
    pluginTable->af->ini_int_load(pluginName, "buttonPosX", &buttonPosX);
    pluginTable->af->ini_int_load(pluginName, "buttonPosY", &buttonPosY);
    pluginTable->af->ini_str_load(pluginName, "tsFormat", tsFormat, MAX_LEN);

    pluginTable->af->ini_int_load(indexKey, "iFontSizeH", &fontHeight);
    pluginTable->af->ini_int_load(indexKey, "iStampLocate", &fontAlign);
    pluginTable->af->ini_str_load(indexKey, "pcFontName", fontName, MAX_LEN);

    char buf[MAX_LEN];
    int num;

    if (pluginTable->af->ini_str_load(indexKey, "dwFontColor", buf, MAX_LEN)) {
        fontColor  = strtol(buf, NULL, 0);
    }

    if (pluginTable->af->ini_str_load(indexKey, "dwBackColor", buf, MAX_LEN)) {
        backgroundColor = strtol(buf, NULL, 0);
    }

    pluginTable->af->ini_int_load(indexKey, "iStampType", &num);
    isTransparent = (num != 0);
}

void
ConfigValues::updateAll()
{
    pluginTable->af->ini_int_save(pluginName, "buttonMode", &buttonMode);
    pluginTable->af->ini_int_save(pluginName, "buttonPosX", &buttonPosX);
    pluginTable->af->ini_int_save(pluginName, "buttonPosY", &buttonPosY);
    pluginTable->af->ini_str_save(pluginName, "tsFormat", tsFormat, MAX_LEN);
}

