#ifndef _INC_CONFIGVALUES
#define _INC_CONFIGVALUES

#define PLUGIN_NAME "邠̉"
#define DEF_TIMESTAMPFORMAT "%Y,%m,%d %X"
#define DEF_FONTNAME "Arial"
#define MAX_LEN 255

#define TOP_LEFT     0
#define TOP_RIGHT    1
#define BOTTOM_LEFT  2
#define BOTTOM_RIGHT 3

#define DISABLE           0
#define PREVIOUS_POSITION 1
#define CORNER            2

#define MERGIN_X 4
#define MERGIN_Y 2

class ConfigValues
{
public:
    ConfigValues();
    void setIndex(int i);
    void setPlugin(const INPUT_PLUGIN_TABLE* t);
    void reloadAll();
    void updateAll();

    // setting number
    int index;
    char pluginName[MAX_LEN + 1];

    // plugin config
    char tsFormat[MAX_LEN + 1];
    int  buttonPosX;
    int  buttonPosY;
    int  buttonMode;

    // amarecoco config
    char fontName[MAX_LEN + 1];
    int  fontHeight;
    int  fontAlign;
    long fontColor;
    long backgroundColor;
    bool isTransparent;

private:
    const INPUT_PLUGIN_TABLE* pluginTable;
    char indexKey[MAX_LEN + 1];
};

#endif

